

; Command Set:
; Below are all the commands the host may send to the keyboard:
;
; 0xFF (Reset     Keyboard responds with "ack" (0xFA), then enters "Reset" mode.  (See "Reset" section.)
;
; 0xFE (Resend)   Keyboard responds by resending the last-sent byte.  The exception to this is if the 
;                 last-sent byte was "resend" (0xFE).  If this is the case, the keyboard resends the last
;                 non-0xFE byte. This command is used by the host to indicate an error in reception.
;
; The next six commands can be issued when the keyboard is in any mode, but it only effects the behavior 
; of the keyboard when in "mode 3" (ie, set to scan code set 3.) 
;
; *0xFD (Set Key Type Make) 
;                  Disable break codes and typematic repeat for specified keys.  
;                  Keyboard responds with "ack" (0xFA), then disables scanning (if enabled) and reads a list of
;                  keys from the host.  These keys are specified by their set 3 make codes.  
;                  Keyboard responds to each make code with "ack".  
;                  Host terminates this list by sending an invalid set 3 make code (eg, a valid command.)  
;                  The keyboard then re-enables scanning (if previously disabled).
;
; *0xFC (Set Key Type Make/Break)
;                  Similar to previous command, except this one only disables typematic repeat.
;
; *0xFB (Set Key Type Typematic)
;                  Similar to previous two, except this one only disables break codes.
;
; *0xFA (Set All Keys Typematic/Make/Break)
;                  Keyboard responds with "ack" (0xFA).  Sets all keys to their normal setting (generate scan 
;                  codes on make, break, and typematic repeat)
;
; *0xF9 (Set All Keys Make)
;                  Keyboard responds with "ack" (0xFA).  Similar to 0xFD, except applies to all keys.
;
; *0xF8 (Set All Keys Make/Break)
;                  Keyboard responds with "ack" (0xFA).  Similar to 0xFC, except applies to all keys.
;
; *0xF7 (Set All Keys Typematic)
;                  Keyboard responds with "ack" (0xFA).  Similar to 0xFB, except applies to all keys.
;
; 0xF6 (Set Default)
;                 Load default typematic rate/delay (10.9cps / 500ms), key types (all keys typematic/make/break),
;                 and scan code set (2).
;
; 0xF5 (Disable)  Keyboard stops scanning, loads default values (see "Set Default" command), and waits 
;                 further instructions.
;
; 0xF4 (Enable)   Re-enables keyboard after disabled using previous command.
;
; 0xF3 (Set Typematic Rate/Delay)
;                 Host follows this command with one argument byte that defines the typematic rate and delay 
;                 as follows:
;                              ...AQUI VAI UMA TABELA ...
;
; *0xF2 (Read ID) 
;                 The keyboard responds by sending a two-byte device ID of 0xAB, 0x83. (0xAB is sent first,
;                 followed by 0x83.)
;
; *0xF0 (Set Scan Code Set)
;                 Keyboard responds with "ack", then reads argument byte from the host.  
;                 This argument byte may be 0x01, 0x02, or 0x03 to select scan code set 1, 2, or 3, 
;                 respectively.  The keyboard responds to this argument byte with "ack".  If the argument
;                 byte is 0x00, the keyboard responds with "ack" followed by the current scan code set.
;
; 0xEE (Echo)     The keyboard responds with "Echo" (0xEE).
;
; 0xED (Set/Reset LEDs) 
;                 The host follows this command with one argument byte, that specifies the state of the 
;                 keyboard's Num Lock, Caps Lock, and Scroll Lock LEDs.  
;                 This argument byte is defined as follows:
;
;                 +--------+--------+--------+--------+--------+--------+--------+--------+
;                 |    MSb                                                          LSb   |
;                 +--------+--------+--------+--------+--------+--------+--------+--------+
;                 | Always | Always | Always | Always | Always | Caps   | Num    | Scroll |
;                 |    0   |    0   |    0   |    0   |    0   | Lock   | Lock   | Lock   |
;                 +--------+--------+--------+--------+--------+--------+--------+--------+
;
;
; "Scroll Lock" ......... Scroll Lock LED off(0) / on(1)
; "Num Lock" ............ Num Lock LED    off(0) / on(1)
; "Caps Lock" ........... Caps Lock LED   off(0) / on(1)
;