; -----------------------------------------------------------------------------------------------
; hexag.asm                                                                  Spinelli 26/03/2009
; Retorna nos registradores R1 (nible + significativo) e R0 (nible - significativo) a 
; representacao ASCII dos valores binarios (0 a F) dos nibles de um byte para que possam ser
; exibidos num dispositivo de saida (LCD).
;
; REQUISITOS:
; A macro HEX2ASCII deve ser emitida no inicio do programa para gerar a tabela de substituicao 
; de valores.
;
; ENTRADA:
; O registrador W deve conter o valor a ser transformado.
; -----------------------------------------------------------------------------------------------
 ifndef __hexag_asm
#define __hexag_asm 1
            GLOBAL    HEXAG
HEXAG       movwf     R0                         ; R1 = abcd.efgh
            movwf     R1                         ; R0 = abcd.efgh

    IF __FAMILIA==18
; -----------------------------------------------------------------------------------------------
;          CODIGO PARA FAMILIA 18F                                                    08/06/2011
; -----------------------------------------------------------------------------------------------
            rrcf      R1,f                      ; R0 = xabc.defg 
            rrcf      R1,f                      ; R0 = hxab.cdef
            rrcf      R1,f                      ; R0 = ghxa.bcde
            rrcf      R1,f                      ; R0 = fghx.abcd
            movlw     UPPER(HEX_ASCII)          ; endereco da tabela
            movwf     TBLPTRU                   ; carrega apontador
            movlw     HIGH(HEX_ASCII)           ; endereco da tabela
            movwf     TBLPTRH                   ; carrega apontador
            movlw     0x0F                      ;  w = 0000.1111
            andwf     R1,w                      ; R1 = 0000.abcd --> MSB
            addlw     LOW(HEX_ASCII) 
            movwf     TBLPTRL                   ; estabelece o endereco
            tblrd     *+                        ; le o endereco da linha
            movff     TABLAT,R1                 ; pega o endereco lido
            movlw     0x0F                      ;  w = 0000.1111
            andwf     R0,w                      ; R0 = 0000.efgh --> LSB
            addlw     LOW(HEX_ASCII) 
            movwf     TBLPTRL                   ; estabelece o endereco

            movlw     UPPER(HEX_ASCII)          ; endereco da tabela
            movwf     TBLPTRU                   ; carrega apontador
            movlw     HIGH(HEX_ASCII)           ; endereco da tabela
            movwf     TBLPTRH                   ; carrega apontador

            tblrd     *+                        ; le o endereco da linha
            movff     TABLAT,R0                 ; pega o endereco lido
            return

;
;   VERSAO "TABLE READ" PARA FAMILIA 18F
;            rrcf      R1,f                      ; R0 = xabc.defg 
;            rrcf      R1,f                      ; R0 = hxab.cdef
;            rrcf      R1,f                      ; R0 = ghxa.bcde
;            rrcf      R1,f                      ; R0 = fghx.abcd
;            movlw     0x0F                     ;  w = 0000.1111
;            andwf     R1,f                     ; R1 = 0000.abcd --> MSB
;            movlw     0x0F                     ;  w = 0000.1111
;            andwf     R0,f                     ; R0 = 0000.efgh --> LSB
;            movlw HIGH(HEX_ASCII)
;            movwf PCLATH
;            rlcf      R1,f
;            movf      R1,w
;            call      HEX_ASCII
;            clrf PCLATH
;            movwf     R1
;            movlw HIGH(HEX_ASCII)
;            movwf PCLATH
;            rlcf  R0,f
;            movf      R0,w
;            call      HEX_ASCII
;            clrf PCLATH
;            movwf     R0
;            return
    ENDIF
       
; -----------------------------------------------------------------------------------------------
;          CODIGO PARA FAMILIA 16F                                                    26/03/2009
; -----------------------------------------------------------------------------------------------
    IF __FAMILIA<=16
            rrf       R1,f                     ; R0 = xabc.defg 
            rrf       R1,f                     ; R0 = hxab.cdef
            rrf       R1,f                     ; R0 = ghxa.bcde
            rrf       R1,f                     ; R0 = fghx.abcd
            movlw     0x0F                     ;  w = 0000.1111
            andwf     R1,f                     ; R1 = 0000.abcd --> MSB
            movlw     0x0F                     ;  w = 0000.1111
            andwf     R0,f                     ; R0 = 0000.efgh --> LSB
            movf      R1,w
            call      HEX_ASCII
            movwf     R1
            movf      R0,w
            call      HEX_ASCII
            movwf     R0
            return

    endif
 endif    ; ifndef __hexag_asm
